
Ruby - Bug #17659

Ractor: can't call io/wait methods

02/26/2021 06:23 PM - chucke (Tiago Cardoso)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 3.0.0 Backport: 2.5: DONTNEED, 2.6: DONTNEED, 2.7:

DONTNEED, 3.0: DONE

Description

It seems that I can use IO.select inside a ractor, but not call IO.wait_writable, which seems odd.

require "io/wait"

ractors = []

1.times do

  ractors << Ractor.new do

    $stdout.wait_writable(2) # this fails

    # but this works

    # IO.select(nil, [$stdout], nil, 2)

    $stdout.puts "wow"

  end

end

ractors.map(&:take)

Related issues:

Blocked by Ruby - Bug #17672: Ractor stdio does not belong to the ractor Closed

Associated revisions

Revision e050dd53230cb354e816415f8a937901f79ec395 - 03/13/2021 08:56 AM - naruse (Yui NARUSE)

merge revision(s) f6d5de8f33fe715d939e3e77b8ef73d88bcd6c9f: [Backport #17659]

    [ruby/io-wait] Declare as Ractor-safe

    Fixes https://bugs.ruby-lang.org/issues/17659

    https://github.com/ruby/io-wait/commit/ba338b4764

    ---

     ext/io/wait/wait.c          |  4 ++++

     test/io/wait/test_ractor.rb | 22 ++++++++++++++++++++++

     2 files changed, 26 insertions(+)

     create mode 100644 test/io/wait/test_ractor.rb

Revision e050dd53230cb354e816415f8a937901f79ec395 - 03/13/2021 08:56 AM - naruse (Yui NARUSE)

merge revision(s) f6d5de8f33fe715d939e3e77b8ef73d88bcd6c9f: [Backport #17659]

    [ruby/io-wait] Declare as Ractor-safe

    Fixes https://bugs.ruby-lang.org/issues/17659

    https://github.com/ruby/io-wait/commit/ba338b4764

    ---

     ext/io/wait/wait.c          |  4 ++++

     test/io/wait/test_ractor.rb | 22 ++++++++++++++++++++++

     2 files changed, 26 insertions(+)

     create mode 100644 test/io/wait/test_ractor.rb

Revision e050dd53 - 03/13/2021 08:56 AM - naruse (Yui NARUSE)

merge revision(s) f6d5de8f33fe715d939e3e77b8ef73d88bcd6c9f: [Backport #17659]

    [ruby/io-wait] Declare as Ractor-safe

    Fixes https://bugs.ruby-lang.org/issues/17659
    https://github.com/ruby/io-wait/commit/ba338b4764

    ---

     ext/io/wait/wait.c          |  4 ++++

     test/io/wait/test_ractor.rb | 22 ++++++++++++++++++++++

     2 files changed, 26 insertions(+)

     create mode 100644 test/io/wait/test_ractor.rb

History

#1 - 03/06/2021 03:41 AM - nobu (Nobuyoshi Nakada)

- Blocked by Bug #17672: Ractor stdio does not belong to the ractor added

#2 - 03/07/2021 01:36 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

#3 - 03/07/2021 01:37 AM - nobu (Nobuyoshi Nakada)

- Backport changed from 2.5: UNKNOWN, 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0: UNKNOWN to 2.5: DONTNEED, 2.6: DONTNEED, 2.7:

DONTNEED, 3.0: REQUIRED

#4 - 03/13/2021 08:56 AM - naruse (Yui NARUSE)

- Backport changed from 2.5: DONTNEED, 2.6: DONTNEED, 2.7: DONTNEED, 3.0: REQUIRED to 2.5: DONTNEED, 2.6: DONTNEED, 2.7:

DONTNEED, 3.0: DONE

ruby_3_0 e050dd53230cb354e816415f8a937901f79ec395 merged revision(s) f6d5de8f33fe715d939e3e77b8ef73d88bcd6c9f.
